/* $Id: utils.js,v 1.1 2004/09/06 21:03:27 ebricca Exp $ */
/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 *
 * The Initial Developer of the Original Code is
 * Ernesto Bricca.
 * Portions created by the Initial Developer are Copyright (C) 2004
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

// dump service  ----

function dumpd(aString)
{
 this.debug = prefs.talktoPref("refspoof.debug", null, false);
 if (this.debug){
   dumpme(aString)
 }
};


function dumpme(aString)
{
	if (typeof(cdump) == 'function') {

		debug = prefs.talktoPref("refspoof.debugCli", null, false)
		if (!this.inited && debug){
			prefs.talktoPref("browser.dom.window.dump.enabled", true);
			registerConsoleListener();
			this.inited=true;
		}
		if (this.inited && !debug){
			unregisterConsoleListener();
			this.inited=false;
		} 

		cdump('debug: ' + aString.toString() + '\n');

	} else {
		prefs.talktoPref("browser.dom.window.dump.enabled", true);
		dump('debug: ' + aString.toString() + '\n'); 
		dump('debug: ' + "console-listener.js is missing" + '\n'); 
	}
};


// pref service ----

var prefs = {

	talktoPref : function (myId, myVal, myInitVal, myBranch) {
		if (myId == null) {
			dumpa("specify a store id");
			return;
		} else if (myVal == null) {
			try {
				return this.getPref(myId, myBranch);
			} catch(ex) {
				if (myInitVal == null){
					dumpme("no initval was given .. bad!!");
					return undefined;
				}
				return this.talktoPref(myId, myInitVal, myBranch); // init
			}
		} else {
			try {
				this.setPref(myId, myVal, myBranch);
				return this.getPref(myId, myBranch);
			} catch(ex) {
				dumpme("bad as - " + ex + " - should have been catched earlier -- happens on wrong format")
			}
 		 }
	},


	getPref : function (myId, myBranch) {
		myPrefS = this.grabPrefS(myBranch);
                type=myPrefS.getPrefType(myId); //bool==128, string==32, int==64
		//dumpd( myId + "on branch" + myBranch +" = " + type + " -- bool==128, string==32, int==64");
		switch (type){
			case 32:
				return myPrefS.getCharPref(myId);
			case 64:
				return myPrefS.getIntPref(myId);
			case 128:
				return myPrefS.getBoolPref(myId);
			case 0:
				throw "pref not defined";
		}
 		 dumpme("no get matchtype");
	},

	setPref : function (myId, myVal, myBranch) {
		myPrefS = this.grabPrefS(myBranch);
		type = typeof(myVal);
		//dumpd(myId + " = " + type);
		switch (type){
			case "string":
				return myPrefS.setCharPref(myId, myVal);
			case "number":
				return myPrefS.setIntPref(myId, myVal);
			case "boolean":
				return myPrefS.setBoolPref(myId, myVal);
		}
  		dumpme("no set matchtype");
	},

	grabPrefS : function (myBranch) {
		if (!this.myPrefS){
			this.myPrefS = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
		}
		if (myBranch == null) {
		myBranch = "";
		}
		return this.myPrefS.getBranch(myBranch);
	}
}

function detectKbSwitch(event, myId, myKey) {
	reverse=false;

	if (myKey=="alt") {
		if (event.altKey){
			reverse=true;
		}
	} else if (myKey=="shift"){
		if (event.shiftKey){
			reverse=true;
		}
	}

	if (reverse) {
		// testline of the using script
		//Boolean(Number(prefs.talktoPref(myId, null, 0)));

		// note to be reversed after usage .. useing function has also to call resetKbSwitch(myId)
		prefs.talktoPref(myId+"Switch", 1);
	}

// .. the first idea was a timeout variant though it seemed a bit hacky
};

function resetKbSwitch(myId) {

// needs to be called at the end of the instruction that uses detectKbSwitch 

	prefs.talktoPref(myId+"Switch", 0);

};
